local HeadCount = LibStub("AceAddon-3.0"):NewAddon("HeadCount2", "AceEvent-3.0", "AceConsole-3.0")
if not HeadCount then return end
-- Load Locales
local L = LibStub("AceLocale-3.0"):GetLocale("HeadCount2")

-- class functionality hooks

function HeadCount:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("HeadCount2DB", self:GetDBDefaults(), "Default")
	self.db.RegisterCallback(self, "OnProfileChanged", "Reset")
	self.db.RegisterCallback(self, "OnProfileCopied", "Reset")
	self.db.RegisterCallback(self, "OnProfileReset", "Reset")
	self.db.RegisterCallback(self, "OnDatabaseShutdown","Serialize")
	-- Setup constants
	self:InitializeConstants()
end

function HeadCount:Serialize()
	-- Remove metadata methods from our data?
	-- Sicne AceDB-3.0 doesnt support OO like AceDB-2.0 did we need to do some magic here.
end

function HeadCount:OnEnable()
	
	self:AddClassMeta(self.db.profile.test)
	print(self.db.profile.test:toString())
	local m = self.db.profile.test
	if #m.players < 5 then
		local nloot = self:NewInstance("Player")
		nloot.sex = 2
		tinsert(m.players,nloot)
	end
	m.players[5].lastActivityTime = nil
	m.players[5].timeList[1] = self:NewInstance("TimePair", {start = 1, stop = 1, note = "t"})
	m.players[5]:moveToRaidList(self:NewInstance("Time",time()))
	--local b = self:NewInstance("Boss",{ name ="Test", zone = "IronForge"})
	--local m = self:NewInstance("Loot")
	--b.players[1] = m
	--local m = self.Boss:New(self.db.profile.test)
	--print(m.name)
	--local b = self.Boss:New({})
	--print(b.name)
	--b.name ="TestBoss"
	--self.db.profile.test = b
end

function HeadCount:OnDisable()
end

function HeadCount:Reset()
end
